layui.define(['view', 'theme', 'common'], function (exports) {
	var $ = layui.jquery,
		element = layui.element,
		theme = layui.theme,
		setter = layui.setter,
		view = layui.view,
		device = layui.device,
		common = layui.common,
		tabsPage = common.tabsPage,
		$win = $(window),
		$body = $('body'),
		container = $('#' + setter.container),
		SHOW = 'layui-show',
		HIDE = 'layui-hide',
		THIS = 'layui-this',
		APP_BODY = '#LAY_app_body',
		APP_FLEXIBLE = 'kdayun-app-flexible',
		FILTER_TAB_TBAS = 'layadmin-layout-tabs',
		APP_SPREAD_SM = 'layadmin-side-spread-sm',
		TABS_BODY = 'layadmin-tabsbody-item',
		ICON_SHRINK = 'layui-icon-shrink-right',
		ICON_SPREAD = 'layui-icon-spread-left',
		SIDE_SHRINK = 'layadmin-side-shrink',
		SIDE_MENU = 'LAY-system-side-menu',
		//通用方法
		admin = {
			//数据的异步请求
			req: view.req,
			// 主题数据
			zltheme: null,
			// 所有主题数据
			allThemeData: null,

			//屏幕类型
			screen: function () {
				var width = $win.width()
				if (width >= 1200) {
					return 3; //大屏幕
				} else if (width >= 992) {
					return 2; //中屏幕
				} else if (width >= 768) {
					return 1; //小屏幕
				} else {
					return 0; //超小屏幕
				}
			},

			//清除本地 token，并跳转到登入页
			exit: view.exit,

			//侧边伸缩
			sideFlexible: function (status) {
				var app = container,
					iconElem = $('#' + APP_FLEXIBLE),
					screen = admin.screen();

				//设置状态，PC：默认展开、移动：默认收缩
				if (status === 'spread') {
					//切换到展开状态的 icon，箭头：←
					iconElem.removeClass(ICON_SPREAD).addClass(ICON_SHRINK);

					//移动：从左到右位移；PC：清除多余选择器恢复默认
					if (screen < 2) {
						app.addClass(APP_SPREAD_SM);
					} else {
						app.removeClass(APP_SPREAD_SM);
					}

					app.removeClass(SIDE_SHRINK)
				} else {
					//切换到搜索状态的 icon，箭头：→
					iconElem.removeClass(ICON_SHRINK).addClass(ICON_SPREAD);

					//移动：清除多余选择器恢复默认；PC：从右往左收缩
					if (screen < 2) {
						app.removeClass(SIDE_SHRINK);
					} else {
						app.addClass(SIDE_SHRINK);
					}

					app.removeClass(APP_SPREAD_SM)
				}

				layui.event.call(this, setter.MOD_NAME, 'side({*})', {
					status: status
				});
			},


			/**
			 * 获取当前用户信息
			 * @param {*} callback 用户信息完成获取回调
			 */
			getUserInfo(callback) {
				$.ajax({
					url: layui.cache['contentPath'] + '/admin/coreuser/querycuruserinfo',
					type: 'post',
					async: false,
					dataType: 'json',
					contentType: "application/json",
					success: function (result) {
						if (result.state == 'OK') {
							callback && callback(result.obj, null)
						} else {
							callback && callback(null, result.msg)
						}
					},
					error: function (xhr) {
						callback && callback(null, '请求异常:' + xhr.responseText)
					},
				});

			},
			//事件监听
			on: function (events, callback) {
				return layui.onevent.call(this, setter.MOD_NAME, events, callback);
			},
			/**
			 * 处理接收到的消息
			 * @param {*} msg 
			 */
			doMessage: function (msg) {
				let d = JSON.parse(msg);
				if (d && d.msg == 'openTabPage') {
					common.openTabsPage(d.params.url, d.params.title, d.params.resid, d.params.paramm, function () {
						var tabId = d.params.resid ? d.params.resid : d.params.url;
						admin.tabsBodyChange(tabsPage.index, {
							url: tabId,
							text: d.params.title
						});
					});
				}
				if (d && d.msg == 'openTopPage') {
					common.openLayerPage(d.params.pageCoinfg, d.params.param);
				}
			},
			//弹出面板
			popup: view.popup,
			//右侧面板
			popupRight: function (options) {
				return admin.popup.index = layer.open($.extend({
					type: 1,
					id: 'LAY_adminPopupR',
					anim: -1,
					title: false,
					closeBtn: false,
					offset: 'r',
					shade: 0.1,
					shadeClose: true,
					skin: 'layui-anim layui-anim-rl layui-layer-adminRight',
					area: '300px'
				}, options));
			},


			//获取页面标签主体元素
			tabsBody: function (index) {
				return $(APP_BODY).find('.' + TABS_BODY).eq(index || 0);
			},

			//切换页面标签主体
			tabsBodyChange: function (index, options) {
				options = options || {};
				element.tabChange(FILTER_TAB_TBAS, options.url);
				admin.tabsBody(index).addClass(SHOW).siblings().removeClass(SHOW);
				events.rollPage('auto', index);

			},

			//resize事件管理
			resize: function (fn) {
				var router = layui.router(),
					key = router.path.join('-');
				$win.off('resize', admin.resizeFn[key]);
				fn(), admin.resizeFn[key] = fn;
				$win.on('resize', admin.resizeFn[key]);
			},
			resizeFn: {},
			runResize: function () {
				var router = layui.router(),
					key = router.path.join('-');
				admin.resizeFn[key] && admin.resizeFn[key]();
			},
			delResize: function () {
				var router = layui.router(),
					key = router.path.join('-');
				$win.off('resize', admin.resizeFn[key])
				delete admin.resizeFn[key];
			},

			//关闭当前 pageTabs
			closeThisTabs: function () {
				if (!common.tabsPage.index) return;
				$(TABS_HEADER).eq(common.tabsPage.index).find('.layui-tab-close').trigger('click');
			},

			//全屏
			fullScreen: function () {
				var ele = document.documentElement,
					reqFullScreen = ele.requestFullScreen || ele.webkitRequestFullScreen ||
						ele.mozRequestFullScreen || ele.msRequestFullscreen;
				if (typeof reqFullScreen !== 'undefined' && reqFullScreen) {
					reqFullScreen.call(ele);
				}
			},

			//退出全屏
			exitScreen: function () {
				// var ele = document.documentElement
				if (document.exitFullscreen) {
					document.exitFullscreen();
				} else if (document.mozCancelFullScreen) {
					document.mozCancelFullScreen();
				} else if (document.webkitCancelFullScreen) {
					document.webkitCancelFullScreen();
				} else if (document.msExitFullscreen) {
					document.msExitFullscreen();
				}
			}
			//……
		};

	//事件
	var events = admin.events = {
		//伸缩
		flexible: function (othis) {
			var iconElem = othis.find('#' + APP_FLEXIBLE),
				isSpread = iconElem.hasClass(ICON_SPREAD);
			admin.sideFlexible(isSpread ? 'spread' : null);
		},
		/**
		 * 刷新
		 */
		refresh: function () {
			var iframe = admin.tabsBody(common.tabsPage.index).find('.layadmin-iframe');
			//$('.layadmin-tabsbody-shade').show();
			iframe.attr('src', iframe.attr('src'));
		},

		/**
		 * 点击消息
		 * @param {*} othis 
		 */
		message: function (othis) {
			othis.find('.layui-badge-dot').remove();
		},

		/**
		 * 弹出主题面板
		 */
		theme: function () {
			admin.popupRight({
				id: 'LAY_adminPopupTheme',
				content: '<div class="layui-card-header">主题管理</div>' +
					'<div class="layui-card-body layadmin-setTheme">' +
					'   <ul class="layadmin-setTheme-color"></ul>' +
					'</div>',
				success: function () {
					var userData = null;

					$.ajax({
						url: layui.cache['contentPath'] + '/admin/coreuser/querycuruserinfo',
						type: "POST",
						async: false,
						data: {},
						dataType: "json",
						contentType: "application/json",
						success: function (data) {
							if (data.state == 'OK') {
								userData = data.obj;
							}
						}
					});
					theme.getThemes(userData.currentOrgId, function (themedata, err) {
						if (themedata) {
							admin.allThemeData = themedata;
						} else {
							admin.allThemeData = [theme.getDefaultTheme()];
						}
						let themeStr = '';
						for (var i = 0; i < admin.allThemeData.length; i++) {
							var item = admin.allThemeData[i],
								flag = '',
								currentTheme = theme.getTheme(false);

							if (currentTheme) {
								if (currentTheme.id === item.id) {
									flag = 'layui-this';
								}
							} else {
								if (item.id === '25CE6A8B1C') {
									flag = 'layui-this';
								}
							}

							themeStr += '<li layadmin-event="setTheme" data-tid="' + item.id + '" data-alias="' + item['theme_title-py'] + '" class="' + flag + '" title="' + item.theme_title + '">' +
								'  <div class="layadmin-setTheme-title">' + item.theme_title + '</div>' +
								'  <div class="layadmin-setTheme-header" style="background-color: ' + item.navBgInput + ';"></div>' +
								function getLayoutHtml() {
									if (item.layout == 'top') {
										return ''
									} else {
										return '  <div class="layadmin-setTheme-side" style="background-color: ' + item.menuBgInput + ';">' +
											'    <div class="layadmin-setTheme-logo" style="background-color: ' + item.logoBgInput + ';"></div>' +
											'  </div>'
									}
								}() +
								'</li>'
						}
						$('#LAY_adminPopupTheme').find('ul.layadmin-setTheme-color').html(themeStr);
					})
				}
			});
		},


		/**
		 * 全屏
		 * @param {*} othis 
		 */
		fullscreen: function (othis) {
			var SCREEN_FULL = 'layui-icon-screen-full',
				SCREEN_REST = 'layui-icon-screen-restore',
				iconElem = othis.children("i");

			if (iconElem.hasClass(SCREEN_FULL)) {
				admin.fullScreen();
				iconElem.addClass(SCREEN_REST).removeClass(SCREEN_FULL);
			} else {
				admin.exitScreen();
				iconElem.addClass(SCREEN_FULL).removeClass(SCREEN_REST);
			}
		},

		/**
		 * 弹出关于面板
		 */
		about: function () {
			admin.popupRight({
				id: 'LAY_adminPopupAbout',
				success: function () {
					view(this.id).render('system/about')
				}
			});
		},

		/**
		 * 弹出更多面板
		 */
		more: function () {
			admin.popupRight({
				id: 'LAY_adminPopupMore',
				success: function () {
					view(this.id).render('system/more')
				}
			});
		},

		/**
		 * 返回上一页
		 */
		back: function () {
			history.back();
		},

		/**
		 * 主题设置
		 * @param {*} othis 
		 */
		setTheme: function (othis) {
			if (othis.hasClass(THIS)) return;
			othis.addClass(THIS).siblings('.layui-this').removeClass(THIS);
			var themes = admin.allThemeData;
			for (var i = 0; i < themes.length; i++) {
				let themeData = themes[i]
				if (themeData.id === othis.attr('data-tid')) {
					var params = {};
					params.UPD_SHIYCJID = 'BDB8E796652148F49E89D53CE0473E4A';
					params.UPD_CONTENT = themeData.id;
					$.ajax({
						url: layui.cache['contentPath'] + "/admin/coreupd/modify",
						type: 'POST',
						async: false,
						data: params,
						dataType: 'json',
						success: function (result) {
							if (result.state == 'OK') {
								theme.setTheme(themeData);
							}
						}
					});
					break;
				}
			}
		},

		//左右滚动页面标签
		rollPage: function (type, index) {
			var tabsHeader = $('#LAY_app_tabsheader'),
				liItem = tabsHeader.children('li'),
				// scrollWidth = tabsHeader.prop('scrollWidth'),
				outerWidth = tabsHeader.outerWidth(),
				tabsLeft = parseFloat(tabsHeader.css('left'));

			//右左往右
			if (type === 'left') {
				if (!tabsLeft && tabsLeft <= 0) return;

				//当前的left减去可视宽度，用于与上一轮的页标比较
				var prefLeft = -tabsLeft - outerWidth;

				liItem.each(function (index, item) {
					var li = $(item),
						left = li.position().left;

					if (left >= prefLeft) {
						tabsHeader.css('left', -left);
						return false;
					}
				});
			} else if (type === 'auto') { //自动滚动
				(function () {
					var thisLi = liItem.eq(index),
						thisLeft;

					if (!thisLi[0]) return;
					thisLeft = thisLi.position().left;

					//当目标标签在可视区域左侧时
					if (thisLeft < -tabsLeft) {
						return tabsHeader.css('left', -thisLeft);
					}

					//当目标标签在可视区域右侧时
					if (thisLeft + thisLi.outerWidth() >= outerWidth - tabsLeft) {
						var subLeft = thisLeft + thisLi.outerWidth() - (outerWidth - tabsLeft);
						liItem.each(function (i, item) {
							var li = $(item),
								left = li.position().left;

							//从当前可视区域的最左第二个节点遍历，如果减去最左节点的差 > 目标在右侧不可见的宽度，则将该节点放置可视区域最左
							if (left + tabsLeft > 0) {
								if (left - tabsLeft > subLeft) {
									tabsHeader.css('left', -left);
									return false;
								}
							}
						});
					}
				}());
			} else {
				//默认向左滚动
				liItem.each(function (i, item) {
					var li = $(item),
						left = li.position().left;

					if (left + li.outerWidth() >= outerWidth - tabsLeft) {
						tabsHeader.css('left', -left);
						return false;
					}
				});
			}
		},

		//向右滚动页面标签
		leftPage: function () {
			events.rollPage('left');
		},

		//向左滚动页面标签
		rightPage: function () {
			events.rollPage();
		},
		setPrevAndNext: function () {
			var topLayui = parent === self ? layui : window.layui;
			topLayui.common.setPrevAndNext();
			if ($('.layui-icon-prev').is(':hidden')) {
				events.leftPage();
			}
		},

		//关闭当前标签页
		closeThisTabs: function () {
			admin.closeThisTabs();
			events.setPrevAndNext();
		},

		//关闭其它标签页
		closeOtherTabs: function (type) {
			var TABS_REMOVE = 'LAY-system-pagetabs-remove';
			if (type === 'all') {
				$(TABS_HEADER + ':gt(0)').remove();
				$(APP_BODY).find('.' + TABS_BODY + ':gt(0)').remove();

				$(TABS_HEADER).eq(0).trigger('click');
			} else {
				var curitem;
				$(TABS_HEADER).each(function (index, item) {
					if (index && index != common.tabsPage.index) {
						$(item).addClass(TABS_REMOVE);
						admin.tabsBody(index).addClass(TABS_REMOVE);
					} else {
						curitem = $(item);
					}
				});
				$('.' + TABS_REMOVE).remove();
				if (curitem) {
					curitem.trigger('click');
				}
				if ($('#LAY_app_tabsheader').position().left != 0) {
					$('#LAY_app_tabsheader').css('left', 0)
				}
			}
			events.setPrevAndNext();
		},

		//关闭全部标签页
		closeAllTabs: function () {
			events.closeOtherTabs('all');
		},

		// 刷新当前子页面
		refreshCurrentPage: function () {
			events.refresh();
		},

		//遮罩
		shade: function () {
			admin.sideFlexible();
		},

		//呼出IM 示例
		im: function () {
			admin.popup({
				id: 'LAY-popup-layim-demo', //定义唯一ID，防止重复弹出
				shade: 0,
				area: ['800px', '300px'],
				title: '面板外的操作示例',
				offset: 'lb',
				success: function () {
					//将 views 目录下的某视图文件内容渲染给该面板
					layui.view(this.id).render('layim/demo').then(function () {
						layui.use('im');
					});
				}
			})
		}
	};



	//监听 tab 组件切换，同步 index
	element.on('tab(' + FILTER_TAB_TBAS + ')', function (data) {
		common.tabsPage.index = data.index;
	});

	//监听选项卡切换，改变菜单状态
	admin.on('tabsPage(setMenustatus)', function (router) {
		var pathURL = router.url,
			getData = function (item) {
				return {
					list: item.children('.yh-menu-child'),
					a: item.children('*[yh-href]')
				}
			},
			sideMenu = $('#' + SIDE_MENU),
			SIDE_NAV_ITEMD = 'layui-nav-itemed',
			//捕获对应菜单
			matchMenu = function (list) {
				list.each(function (index1, item1) {
					var othis1 = $(item1),
						data1 = getData(othis1),
						listChildren1 = data1.list.children('dd'),
						matched1 = pathURL === data1.a.attr('resid');

					listChildren1.each(function (index2, item2) {
						var othis2 = $(item2),
							data2 = getData(othis2),
							listChildren2 = data2.list.children('dd'),
							matched2 = pathURL === data2.a.attr('resid');

						listChildren2.each(function (index3, item3) {
							var othis3 = $(item3),
								data3 = getData(othis3),
								matched3 = pathURL === data3.a.attr('resid');

							if (matched3) {
								var selected = data3.list[0] ? SIDE_NAV_ITEMD : THIS;
								othis3.parents('dd').addClass(SIDE_NAV_ITEMD).siblings().removeClass(SIDE_NAV_ITEMD);
								othis3.parents('li.layui-nav-item').addClass(SIDE_NAV_ITEMD).siblings().removeClass(SIDE_NAV_ITEMD);
								othis3.addClass(selected).siblings().removeClass(selected); //标记选择器
								return false;
							}
						});

						if (matched2) {
							var selected = data2.list[0] ? SIDE_NAV_ITEMD : THIS;
							othis2.parents('li.layui-nav-item').addClass(SIDE_NAV_ITEMD).siblings().removeClass(SIDE_NAV_ITEMD);
							othis2.addClass(selected).siblings().removeClass(selected); //标记选择器
							return false
						}
					});

					if (matched1) {
						var selected = data1.list[0] ? SIDE_NAV_ITEMD : THIS;
						othis1.addClass(selected).siblings().removeClass(selected); //标记选择器
						return false;
					}
				});
			}

		//重置状态
		sideMenu.find('.' + THIS).removeClass(THIS);

		//移动端点击菜单时自动收缩
		if (admin.screen() < 2) admin.sideFlexible();

		//开始捕获
		matchMenu(sideMenu.children('li'));
	});

	//监听侧边导航点击事件
	element.on('nav(layadmin-system-side-menu)', function (elem) {
		if (!window.navigator.onLine && elem.attr('yh-href')) {
			// '网络未连接， 请检查网络后刷新页面'
			layer.open({
				type: 1,
				title: false,
				closeBtn: 0,
				offset: 'r',
				shade: 0,
				id: 'offline',
				area: ['calc(100% - 220px)', '100%'],
				content: '<div style="text-align: center;padding-top: 50px;">' +
					'  <i class="layui-icon layui-icon-404" style="font-size: 250px;"></i>' +
					'  <div style="font-size: 20px;">网络未连接， 请检查网络后刷新页面</div>' +
					'</div>'
			})
			return;
		}
		$('#offline').parent().remove()
		if (elem.siblings('.layui-nav-child')[0] && container.hasClass(SIDE_SHRINK)) {
			admin.sideFlexible('spread');
			layer.close(elem.data('index'));
		}
		common.tabsPage.type = 'nav';
	});

	//监听选项卡的更多操作
	element.on('nav(layadmin-pagetabs-nav)', function (elem) {
		var dd = elem.parent();
		dd.removeClass(THIS);
		dd.parent().removeClass(SHOW);
	});
	// $body.on('click', '#kd-tabs-select', function (e) {
	// 	var child = $(e.currentTarget).find('.layui-nav-child')
	// 	child.addClass(SHOW);
	// })


	//同步路由
	var setThisRouter = function (othis) {
		var layid = othis.attr('lay-id'),
			// attr = othis.attr('lay-attr'),
			index = othis.index();
		admin.tabsBodyChange(index, {
			url: layid
		});
		location.hash = layid === setter.entry ? '/' : '';
	},
		TABS_HEADER = '#LAY_app_tabsheader>li';

	//标签页标题点击
	$body.on('click', TABS_HEADER, function () {
		if ($('.layadmin-tabsbody-shade').length > 0) {
			$('.layadmin-tabsbody-shade').hide()
		}
		var othis = $(this),
			index = othis.index();
		common.tabsPage.type = 'tab';
		common.tabsPage.index = index;

		//单页标签页
		setThisRouter(othis);
	});

	//监听 tabspage 删除
	element.on('tabDelete(' + FILTER_TAB_TBAS + ')', function (obj) {
		var tab = obj.elem.find('li').eq(obj.index)
		let $iframe = admin.tabsBody(obj.index).find('iframe');
		if ($iframe.length > 0) {
			try {
				yhpreview = $iframe[0].contentWindow['yhpreview'];
				if (yhpreview && yhpreview.getPage() && yhpreview.getPage().hasDataChanged()) {
					layer.msg('存在未保存的数据,请先保存数据再关闭页面');
					obj.canClose = false;
					return;
				}
			} catch (error) {
				//这里忽略一些跨域访问iframe的问题错误 
			}

		}
		if (obj.canClose !== false) {
			if (tab.hasClass('layui-this')) {
				if (tab.next()[0]) {
					setThisRouter(tab.next());
				} else if (tab.prev()[0]) {
					setThisRouter(tab.prev());
				}
			}
		}
		obj.index && admin.tabsBody(obj.index).remove();
		//移除resize事件
		admin.delResize();
		events.setPrevAndNext();
	});

	//页面跳转
	$body.on('click', '*[yh-href]', function () {
		if (!window.navigator.onLine) return;
		var othis = $(this),
			href = othis.attr('yh-href'),
			text = othis.attr('lay-text'),
			resid = othis.attr('resid');

		common.tabsPage.elem = othis;
		//执行跳转
		common.openTabsPage(href, text || othis.text(), resid);
	});

	//点击事件
	$body.on('click', '*[layadmin-event]', function () {
		var othis = $(this),
			attrEvent = othis.attr('layadmin-event');
		events[attrEvent] && events[attrEvent].call(this, othis);
	});

	//tips
	$body.on('mouseenter', '*[lay-tips]', function () {
		var othis = $(this);
		if (othis.parent().hasClass('layui-nav-item') && !container.hasClass(SIDE_SHRINK)) return;
		var tips = othis.attr('lay-tips'),
			offset = othis.attr('lay-offset'),
			direction = othis.attr('lay-direction'),
			index = layer.tips(tips, this, {
				tips: direction || 1,
				time: -1,
				// ,id: 'menuTips'
				success: function (layero, index) {
					layero.addClass('menuTips')
					if (offset) {
						layero.css('margin-left', offset + 'px');
					}
					setTimeout(function () {
						layero.show()
					}, 1000)
				}
			});
		othis.data('index', index);
	}).on('mouseleave', '*[lay-tips]', function () {
		layer.close($(this).data('index'));
	});

	//窗口resize事件
	var resizeSystem = layui.data.resizeSystem = function () {
		layer.closeAll('tips');
		if (!resizeSystem.lock) {
			setTimeout(function () {
				admin.sideFlexible(admin.screen() < 2 ? '' : 'spread');
				delete resizeSystem.lock;
			}, 100);
		}
		resizeSystem.lock = true;
	}
	$win.on('resize', layui.data.resizeSystem);

	/**
	 * 渲染角色下拉
	 * @param {*} loginInfo 登录的返回信息 
	 */
	function renderRoles(loginInfo) {
		var html = '',
			rolelist = loginInfo.roleCursor,
			$rolecourse = $('#rolecourse');

		if (loginInfo.currentDeptName == '') {
			$('#ROLENAME').html(loginInfo.currentRoleName);
		} else {
			$('#ROLENAME').html(loginInfo.currentDeptName + '-' + loginInfo.currentRoleName);
		}

		$('#ROLENAME').attr('roleid', loginInfo.currentRoleId);
		$('#ROLENAME').attr('deptid', loginInfo.currentDeptId);
		for (var i = 0; i < rolelist.length; i++) {
			html += '<dd>';
			if (rolelist[i].DEPTNAME != "") {
				html += '  <a style="cursor:pointer" name="roleswitch" deptid="' + rolelist[i].DEPTID + '" roleid="' + rolelist[i].ROLEID + '">';
				html += rolelist[i].DEPTNAME + '-' + rolelist[i].ROLENAME;
			} else {
				html += '  <a name="roleswitch" roleid="' + rolelist[i].ROLEID + '">';
				html += rolelist[i].ROLENAME;
			}
			html += '   </a>';
			html += '</dd>';
		}
		$rolecourse.append(html);
		initRoleClickEvent();
	}
	/**
	 * 初始化角色点击事件
	 */
	function initRoleClickEvent() {
		$('#rolecourse a').on('click', function () {
			var curroleid = $('#ROLENAME').attr('roleid'),
				currdeptid = $('#ROLENAME').attr('deptid'),
				switchroleid = $(this).attr('roleid'),
				deptid = $(this).attr('deptid') == undefined ? '' : $(this).attr('deptid'),
				param = {
					roleid: switchroleid,
					deptid: deptid
				}
			if (curroleid == switchroleid && currdeptid == deptid) {
				return;
			} else {
				var index = layer.load();
				$.ajax({
					url: layui.cache['contentPath'] + '/switchRole?t=' + Math.floor(Math.random() * 100),
					data: param,
					type: 'get',
					async: false,
					dataType: 'json',
					contentType: "application/json",
					success: function (result) {
						if (result.state == 'OK') {
							layer.close(index);
							top.location.href = layui.cache['contentPath'] + '/index?tokenId=' + $('#tokenId').val();
						}
					},
					error: function (xhr, textStatus, errorThrown) {
						layer.msg('请求异常!' + xhr.responseText);
					},
				});
			}
		});
	}
	/**
	 * 渲染头像
	 * @param {*} userInfo 用户信息
	 */
	function renderTouX(userInfo) {
		if (userInfo.TOUX != undefined && userInfo.TOUX != null && userInfo.TOUX != '') {
			$('#TOUX').prop('src', layui.cache['contentPath'] + userInfo.TOUX);
		} else {
			$('#TOUX').prop('src', layui.cache['contentPath'] + '/static/image/userImg.png');
		}
	}
	/**
	 * 渲染点击用户名的下拉系统的菜单
	 * @param {*} loginInfo 登录的返回信息 
	 */
	function renderSysMenu(loginInfo) {
		$.ajax({
			url: layui.cache['contentPath'] + '/manager/coresysopt/querybyid',
			type: 'post',
			async: true,
			data: { 'optid': '2F6E174513EE460A971CCD641EC77198' },
			dataType: 'json',
			success: function (setdata) {
				setdata = setdata.obj;
				if (setdata != '') {
					var dataArray = setdata.split(',');
					if (dataArray.length == 1 && dataArray[0] == 'zx') {
						$('#zx').children('hr').hide();
						$('#zx').show();
					} else {
						$.each(dataArray, function (item, v) {
							$('#' + v).show();
						});
					}
				} else {
					$('.setli').hide();
					$('.layui-nav-more').hide();
				}
			},
			error: function (xhr, textStatus, errorThrown) {
				layer.msg('请求异常!' + xhr.responseText);
			},
		});
	}
	/**
	 * 渲染其他,用户名,机构名等
	 * @param {*} userInfo 登录的返回信息
	 */
	function renderOthers(userInfo) {
		$('#OBJNAME').html(userInfo.userCursor.OBJNAME);
		$('#ORGNAME').html(userInfo.currentOrgName);
	}

	/**
	 * 渲染消息
	 */
	function renderMessageBox() {
		// 获取待办信息
		$.ajax({
			url: layui.cache['contentPath'] + '/manager/coremessage/query',
			type: 'get',
			async: false,
			dataType: 'json',
			contentType: "application/json",
			success: function (result) {
				var state = result.state;
				if (state == 'OK') {
					var data = result.obj;
					if (data.length == 0) {
						$('.layui-badge-dot').remove();
					}
				}
			}
		});
	}
	/**
	 * 主题渲染
	 */
	function renderTheme() {
		window['kdtheme'].render(true);
	}

	function renderMenu(userInfo) {
		renderTheme();
		renderTouX(userInfo.userCursor)
		renderRoles(userInfo)
		renderSysMenu(userInfo);
		renderMessageBox();
		renderSysMenu();
		renderOthers(userInfo);
	}

	//初始
	! function () {
		//注册页签改变事件
		admin.on('tabsPage({*})', function (events) {
			admin.tabsBodyChange(common.tabsPage.index, {
				url: events.url,
				text: events.title
			});
		})

		//当前设定主题设置
		let m = theme.getTheme(true);
		if (m) {
			var g_loginInfo = null
			common.on('setTheme', function (event) {
				renderTheme();
				if (g_loginInfo === null) {
					admin.getUserInfo(function (userInfo, error) {
						if (error) {
							layer.msg('获取用户信息异常：' + error);
						} else {
							g_loginInfo = userInfo;
							renderMenu(g_loginInfo)
						}
					})
				} else {
					renderMenu(g_loginInfo)
				}
			})
			theme.setTheme(m);
		}
		/**
		 * 判断是否已经加载主题
		 */
		window['--hasload-kd-Theme'] = true;

		$('body').addClass('loaded');
		$('#loader-wrapper .load_title').remove();

		common.on('TabPageFinished', function (event) {
			$('.layadmin-tabsbody-shade').fadeOut('600');
		})



		//常规版默认开启多标签页
		if (!('pageTabs' in layui.setter)) layui.setter.pageTabs = true

		//不开启页面标签时
		if (!setter.pageTabs) {
			$('#LAY_app_tabs').addClass(HIDE);
			container.addClass('layadmin-tabspage-none');
		}

		//低版本IE提示
		if (device.ie) {
			view.error('IE' + device.ie + '下访问可能不佳，推荐使用：Chrome / Firefox / Edge 等高级浏览器', {
				offset: 'auto'
				, id: 'LAY_errorIE'
			});
		}

	}();

	//接口输出
	exports('admin', admin);
});